//+------------------------------------------------------------------+
//|                                                Spread profit.mq4 |
//|                                                            Costy |
//|       -.|
//|        ,    |
//|  .       |
//|   .                                          |
//+------------------------------------------------------------------+
#property copyright "Costy"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Green
#property indicator_level1 0

extern string Sym1="EURUSD"; // 
extern string Sym2="USDCHF"; // 
extern double Lots1=0.1;     //  
extern double Lots2=0.14;    //  
extern int    same_direction=1;// ,         (1),  (-1)
                               //    [(241)  (242), (251)]
//---- buffers
double profit[];

double in_market[]; //   
double open1[];     //   1- 
double open2[];     //   2- 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- additional buffers are used for counting
   IndicatorBuffers(4);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,profit);
   SetIndexLabel(0,"");
   
   SetIndexBuffer(1,in_market);
   SetIndexBuffer(2,open1);
   SetIndexBuffer(3,open2);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int obj_total=ObjectsTotal();
   int arrcode; // 
   int arrtime; //  
   int i; //  
   int j;
   int counted_bars=IndicatorCounted();

   i=Bars-counted_bars-1;           //      
   while(i>=0)                      //         
   {
      //       
      in_market[i]=in_market[i+1];
      for(int k=0; k<obj_total; k++)
      {
         arrcode = ObjectGet(ObjectName(k),OBJPROP_ARROWCODE);
         arrtime = ObjectGet(ObjectName(k),OBJPROP_TIME1);
         if (arrtime==Time[i])
         {
            if (arrcode==SYMBOL_ARROWUP)  in_market[i]=1; //
            if (arrcode==SYMBOL_ARROWDOWN)in_market[i]=-1;//
            if (arrcode==SYMBOL_STOPSIGN) in_market[i]=0; //
         }
      }
      //   
      open1[i]=open1[i+1];
      open2[i]=open2[i+1];
      if (in_market[i]!=0 && in_market[i+1]==0)
      {
         open1[i]=iOpen(Sym1,Period(),iBarShift(Sym1,Period(),Time[i],false));
         open2[i]=iOpen(Sym2,Period(),iBarShift(Sym2,Period(),Time[i],false));
      }      
      if (in_market[i]==0 && in_market[i+1]!=0)
      {
         open1[i]=0;
         open2[i]=0;
      }   
      //  
      if (in_market[i]!=0)
      {
         //  
         double price1 = iClose(Sym1,Period(),iBarShift(Sym1,Period(),Time[i],false));
         double price2 = iClose(Sym2,Period(),iBarShift(Sym2,Period(),Time[i],false));
         //:
         profit[i] = ((price1-open1[i])*in_market[i]-MarketInfo(Sym1,MODE_SPREAD)*MarketInfo(Sym1,MODE_POINT))/MarketInfo(Sym1,MODE_POINT)*MarketInfo(Sym1,MODE_TICKVALUE)*Lots1+
                     ((price2-open2[i])*in_market[i]*same_direction-MarketInfo(Sym2,MODE_SPREAD)*MarketInfo(Sym2,MODE_POINT))/MarketInfo(Sym2,MODE_POINT)*MarketInfo(Sym2,MODE_TICKVALUE)*Lots2;
      }

      i--;                          //         
   }   
   return(0);
}
//+------------------------------------------------------------------+